Leetcode口试经典150题-128.最长一连序列

[复制链接]
发表于 2026-2-1 02:04:23 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
解法都在代码里,不懂就留言大概私信
理论上提交这个就是最优解
  1. class Solution {
  2.     /**解题思路:定义一个hash表用来保存以某个数字结尾的有多少个连续的数
  3.     刚开始初始化hash表是把整个数组过一遍,然后记录所有数对应的value(以当前数结尾的最长连续序列)都是1
  4.     当我们遍历到某个数字num的时候,如果hash表里能找到num-1的记录就用这个记录的value+1放回hash表
  5.     如果没有找到num-1的记录,就记录为,如果找到了就把当前数的value存到hash表里记录value为num-1的value+1
  6.     但是这种方法要求先排序(O(N*logN)),虽然提交是可以成功的,但是题目确实要求了O(N)的时间复杂度*/
  7.     public int longestConsecutiv2(int[] nums) {
  8.         if(nums == null || nums.length == 0) {
  9.             return 0;
  10.         }
  11.         /**就一个数当然是1 */
  12.         if(nums.length == 1) {
  13.             return 1;
  14.         }
  15.         /**其他的情况我们先排序 */
  16.         Arrays.sort(nums);
  17.         /**定义map用于存放某个数字结尾的连续序列的长度 */
  18.         Map<Integer,Integer> countMap = new HashMap<>();
  19.         countMap.put(nums[0],1);
  20.         /**从1位置开始遍历*/
  21.         for(int i = 1; i < nums.length; i++) {
  22.             countMap.put(nums[i], countMap.getOrDefault(nums[i]-1,0)+1);
  23.         }
  24.         int max = 0;
  25.         for(int num : countMap.values()) {
  26.             max = Math.max(max, num);
  27.         }
  28.         return max;
  29.     }
  30.     /**第二种解法,个人理解应该是最优解了,解法思路是:使用两个map
  31.     一个用来存放以某个数字结尾的map有多长,我们命名为tailMap
  32.     一个用来存放以某个数字开头的map有多长,我们命名为headMap
  33.     每进来一个数num,先看看以num-1结尾的在tailMap里有没有记录,如果有把它的长度+1作为当前num在tail里的记录,同时记录开始的数字是几
  34.     如果没有的话,记录一条以num为key,value为1的记录代表以当前num结尾的最长连续序列长度是1
  35.     然后看看headMap里有没有以num+1开头的,如果有,则取出num在tail里的记录和head里的num+1的记录合并,记录起点和终点
  36.     比如分别是start和end,那在tailmap里记录end结束的集合,在headMap里记录start开始的记录*/
  37.     public int longestConsecutive(int[] nums) {
  38.         if(nums == null || nums.length == 0) {
  39.             return 0;
  40.         }
  41.         /**就一个数当然是1 */
  42.         if(nums.length == 1) {
  43.             return 1;
  44.         }
  45.         /**定义两个map 一个用来存放以某个数字结尾的map有多长,我们命名为tailMap
  46.         一个用来存放以某个数字开头的map有多长,我们命名为headMap */
  47.         Map<Integer,Integer> tailMap = new HashMap<>();
  48.         Map<Integer,Integer> headMap = new HashMap<>();
  49.         for(int num : nums) {
  50.             /**这里一定不要忘了,如果出现重复的数字肯定会让结果变得不正确,因为我们map只put了没有删除
  51.             所以一定不要重复处理 */
  52.             if(tailMap.containsKey(num)) {
  53.                 continue;
  54.             }
  55.             /**我们先处理tailMap,如果有num-1就把值加1,否则使用1(0+1) */
  56.             tailMap.put(num, tailMap.getOrDefault(num - 1, 0) + 1);
  57.             /**拿到以num结尾的长度 */
  58.             int tailLen = tailMap.get(num);
  59.             /**找到以num结尾的长度为tailLen的开始的数 */
  60.             int tailStart = num - tailLen + 1;
  61.             /**先把num放入tailMap */
  62.             tailMap.put(num, tailLen);
  63.             /**如果headMap里有num+1开头的,把以num结尾的和以num+1的串成一个  */
  64.             if(headMap.containsKey(num + 1)) {
  65.                 /**拿到以num+1开头的长度 */
  66.                 int headLen = headMap.get(num + 1);
  67.                 /**拿到以num+1开头的长度为headLen的结尾的数 */
  68.                 int headEnd = num + 1 + headLen -1;
  69.                 /**分别把这个串起来的区间的头和尾分别存入headMap和tailMap里,长度是整个区间的长度tailLen + headLen */
  70.                 tailMap.put(headEnd, tailLen + headLen);
  71.                 headMap.put(tailStart, tailLen + headLen);
  72.             } else {
  73.                 /**如果没有把已num为结尾,以tailLen为长度的开始位置存入headMap */
  74.                 headMap.put(tailStart, tailLen);
  75.             }
  76.         }
  77.         int max = 0;
  78.         /**最后遍历tailMap找最大长度,这里遍历headMap也是一样的 */
  79.         for(int len : tailMap.values()) {
  80.             max = Math.max(max,len);
  81.         }
  82.         return max;   
  83.     }
  84. }
复制代码
但是某网站的数据比力二*,不想说啥,N*longN的解凌驾50%以上的人
O(N)的解凌驾这么点人??

回复

使用道具 举报

登录后关闭弹窗

登录参与点评抽奖  加入IT实名职场社区
去登录
快速回复 返回顶部 返回列表